/* bindkeys.c generated by valac 0.56.16, the Vala compiler
 * generated from bindkeys.vala, do not modify */

/*
 * Copyright 2016 (C) Raster Software Vigo (Sergio Costas)
 *
 * This file is part of Terminus
 *
 * Terminus is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License.
 *
 * Terminus is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>. */

#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <glib-object.h>
#include <keybinder.h>

#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif
#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

#define TERMINUS_TYPE_BINDKEY (terminus_bindkey_get_type ())
#define TERMINUS_BINDKEY(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TERMINUS_TYPE_BINDKEY, TerminusBindkey))
#define TERMINUS_BINDKEY_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TERMINUS_TYPE_BINDKEY, TerminusBindkeyClass))
#define TERMINUS_IS_BINDKEY(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TERMINUS_TYPE_BINDKEY))
#define TERMINUS_IS_BINDKEY_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TERMINUS_TYPE_BINDKEY))
#define TERMINUS_BINDKEY_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TERMINUS_TYPE_BINDKEY, TerminusBindkeyClass))

typedef struct _TerminusBindkey TerminusBindkey;
typedef struct _TerminusBindkeyClass TerminusBindkeyClass;
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
typedef struct _TerminusBindkeyPrivate TerminusBindkeyPrivate;
enum  {
	TERMINUS_BINDKEY_0_PROPERTY,
	TERMINUS_BINDKEY_NUM_PROPERTIES
};
static GParamSpec* terminus_bindkey_properties[TERMINUS_BINDKEY_NUM_PROPERTIES];
#define _g_free0(var) (var = (g_free (var), NULL))
enum  {
	TERMINUS_BINDKEY_SHOW_GUAKE_SIGNAL,
	TERMINUS_BINDKEY_NUM_SIGNALS
};
static guint terminus_bindkey_signals[TERMINUS_BINDKEY_NUM_SIGNALS] = {0};

struct _TerminusBindkey {
	GObject parent_instance;
	TerminusBindkeyPrivate * priv;
};

struct _TerminusBindkeyClass {
	GObjectClass parent_class;
};

struct _TerminusBindkeyPrivate {
	gchar* key;
	gboolean use_bindkey;
};

static gint TerminusBindkey_private_offset;
static gpointer terminus_bindkey_parent_class = NULL;

VALA_EXTERN void terminus_keybind_cb (const gchar* key,
                          void* udata);
VALA_EXTERN GType terminus_bindkey_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (TerminusBindkey, g_object_unref)
VALA_EXTERN TerminusBindkey* terminus_bindkey_new (gboolean use_bindkey);
VALA_EXTERN TerminusBindkey* terminus_bindkey_construct (GType object_type,
                                             gboolean use_bindkey);
VALA_EXTERN gboolean terminus_bindkey_set_bindkey (TerminusBindkey* self,
                                       const gchar* key);
VALA_EXTERN void terminus_bindkey_unset_bindkey (TerminusBindkey* self);
static void _terminus_keybind_cb_keybinder_handler (const gchar* keystring,
                                             void* udata);
static void terminus_bindkey_finalize (GObject * obj);
static GType terminus_bindkey_get_type_once (void);

static gpointer
_g_object_ref0 (gpointer self)
{
	return self ? g_object_ref (self) : NULL;
}

void
terminus_keybind_cb (const gchar* key,
                     void* udata)
{
	TerminusBindkey* obj = NULL;
	TerminusBindkey* _tmp0_;
	g_return_if_fail (key != NULL);
	_tmp0_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (udata, TERMINUS_TYPE_BINDKEY, TerminusBindkey));
	obj = _tmp0_;
	g_signal_emit (obj, terminus_bindkey_signals[TERMINUS_BINDKEY_SHOW_GUAKE_SIGNAL], 0);
	_g_object_unref0 (obj);
}

static inline gpointer
terminus_bindkey_get_instance_private (TerminusBindkey* self)
{
	return G_STRUCT_MEMBER_P (self, TerminusBindkey_private_offset);
}

TerminusBindkey*
terminus_bindkey_construct (GType object_type,
                            gboolean use_bindkey)
{
	TerminusBindkey * self = NULL;
	self = (TerminusBindkey*) g_object_new (object_type, NULL);
	if (check_wayland () != 0) {
		self->priv->use_bindkey = FALSE;
	} else {
		self->priv->use_bindkey = use_bindkey;
	}
	if (self->priv->use_bindkey) {
		keybinder_init ();
	}
	_g_free0 (self->priv->key);
	self->priv->key = NULL;
	return self;
}

TerminusBindkey*
terminus_bindkey_new (gboolean use_bindkey)
{
	return terminus_bindkey_construct (TERMINUS_TYPE_BINDKEY, use_bindkey);
}

static void
_terminus_keybind_cb_keybinder_handler (const gchar* keystring,
                                        void* udata)
{
	terminus_keybind_cb (keystring, udata);
}

gboolean
terminus_bindkey_set_bindkey (TerminusBindkey* self,
                              const gchar* key)
{
	gboolean retval = FALSE;
	gchar* _tmp1_;
	gboolean result;
	g_return_val_if_fail (self != NULL, FALSE);
	g_return_val_if_fail (key != NULL, FALSE);
	if (self->priv->use_bindkey) {
		const gchar* _tmp0_;
		_tmp0_ = self->priv->key;
		if (_tmp0_ != NULL) {
			terminus_bindkey_unset_bindkey (self);
		}
	}
	_tmp1_ = g_strdup (key);
	_g_free0 (self->priv->key);
	self->priv->key = _tmp1_;
	if (self->priv->use_bindkey) {
		retval = keybinder_bind (key, _terminus_keybind_cb_keybinder_handler, self);
		if (retval == FALSE) {
			g_print ("Failed to set the guake_mode bind key\n");
		}
		result = retval;
		return result;
	} else {
		result = TRUE;
		return result;
	}
}

void
terminus_bindkey_unset_bindkey (TerminusBindkey* self)
{
	g_return_if_fail (self != NULL);
	if (self->priv->use_bindkey) {
		const gchar* _tmp0_;
		const gchar* _tmp1_;
		_tmp0_ = self->priv->key;
		if (_tmp0_ == NULL) {
			return;
		}
		_tmp1_ = self->priv->key;
		keybinder_unbind (_tmp1_, _terminus_keybind_cb_keybinder_handler);
		_g_free0 (self->priv->key);
		self->priv->key = NULL;
	}
}

static void
terminus_bindkey_class_init (TerminusBindkeyClass * klass,
                             gpointer klass_data)
{
	terminus_bindkey_parent_class = g_type_class_peek_parent (klass);
	g_type_class_adjust_private_offset (klass, &TerminusBindkey_private_offset);
	G_OBJECT_CLASS (klass)->finalize = terminus_bindkey_finalize;
	terminus_bindkey_signals[TERMINUS_BINDKEY_SHOW_GUAKE_SIGNAL] = g_signal_new ("show-guake", TERMINUS_TYPE_BINDKEY, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
}

static void
terminus_bindkey_instance_init (TerminusBindkey * self,
                                gpointer klass)
{
	self->priv = terminus_bindkey_get_instance_private (self);
}

static void
terminus_bindkey_finalize (GObject * obj)
{
	TerminusBindkey * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TERMINUS_TYPE_BINDKEY, TerminusBindkey);
	_g_free0 (self->priv->key);
	G_OBJECT_CLASS (terminus_bindkey_parent_class)->finalize (obj);
}

static GType
terminus_bindkey_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (TerminusBindkeyClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) terminus_bindkey_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (TerminusBindkey), 0, (GInstanceInitFunc) terminus_bindkey_instance_init, NULL };
	GType terminus_bindkey_type_id;
	terminus_bindkey_type_id = g_type_register_static (G_TYPE_OBJECT, "TerminusBindkey", &g_define_type_info, 0);
	TerminusBindkey_private_offset = g_type_add_instance_private (terminus_bindkey_type_id, sizeof (TerminusBindkeyPrivate));
	return terminus_bindkey_type_id;
}

GType
terminus_bindkey_get_type (void)
{
	static volatile gsize terminus_bindkey_type_id__once = 0;
	if (g_once_init_enter (&terminus_bindkey_type_id__once)) {
		GType terminus_bindkey_type_id;
		terminus_bindkey_type_id = terminus_bindkey_get_type_once ();
		g_once_init_leave (&terminus_bindkey_type_id__once, terminus_bindkey_type_id);
	}
	return terminus_bindkey_type_id__once;
}

