/* macros.c generated by valac 0.56.16, the Vala compiler
 * generated from macros.vala, do not modify */

/*
 * Copyright 2023 (C) Raster Software Vigo (Sergio Costas)
 *
 * This file is part of Terminus
 *
 * Terminus is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License.
 *
 * Terminus is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <glib-object.h>
#include <glib.h>
#include <gdk/gdk.h>
#include <stdlib.h>
#include <string.h>
#include <gtk/gtk.h>
#include <gio/gio.h>

#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif
#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

#define TERMINUS_TYPE_MACRO (terminus_macro_get_type ())
#define TERMINUS_MACRO(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TERMINUS_TYPE_MACRO, TerminusMacro))
#define TERMINUS_MACRO_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TERMINUS_TYPE_MACRO, TerminusMacroClass))
#define TERMINUS_IS_MACRO(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TERMINUS_TYPE_MACRO))
#define TERMINUS_IS_MACRO_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TERMINUS_TYPE_MACRO))
#define TERMINUS_MACRO_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TERMINUS_TYPE_MACRO, TerminusMacroClass))

typedef struct _TerminusMacro TerminusMacro;
typedef struct _TerminusMacroClass TerminusMacroClass;
typedef struct _TerminusMacroPrivate TerminusMacroPrivate;
enum  {
	TERMINUS_MACRO_0_PROPERTY,
	TERMINUS_MACRO_NUM_PROPERTIES
};
static GParamSpec* terminus_macro_properties[TERMINUS_MACRO_NUM_PROPERTIES];
#define _g_free0(var) (var = (g_free (var), NULL))

#define TERMINUS_TYPE_MACROS (terminus_macros_get_type ())
#define TERMINUS_MACROS(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TERMINUS_TYPE_MACROS, TerminusMacros))
#define TERMINUS_MACROS_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TERMINUS_TYPE_MACROS, TerminusMacrosClass))
#define TERMINUS_IS_MACROS(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TERMINUS_TYPE_MACROS))
#define TERMINUS_IS_MACROS_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TERMINUS_TYPE_MACROS))
#define TERMINUS_MACROS_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TERMINUS_TYPE_MACROS, TerminusMacrosClass))

typedef struct _TerminusMacros TerminusMacros;
typedef struct _TerminusMacrosClass TerminusMacrosClass;
typedef struct _TerminusMacrosPrivate TerminusMacrosPrivate;
enum  {
	TERMINUS_MACROS_0_PROPERTY,
	TERMINUS_MACROS_NUM_PROPERTIES
};
static GParamSpec* terminus_macros_properties[TERMINUS_MACROS_NUM_PROPERTIES];
#define _g_variant_unref0(var) ((var == NULL) ? NULL : (var = (g_variant_unref (var), NULL)))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_variant_iter_free0(var) ((var == NULL) ? NULL : (var = (g_variant_iter_free (var), NULL)))

struct _TerminusMacro {
	GObject parent_instance;
	TerminusMacroPrivate * priv;
};

struct _TerminusMacroClass {
	GObjectClass parent_class;
};

struct _TerminusMacroPrivate {
	guint keyval;
	GdkModifierType state;
	gchar* command;
};

struct _TerminusMacros {
	GObject parent_instance;
	TerminusMacrosPrivate * priv;
};

struct _TerminusMacrosClass {
	GObjectClass parent_class;
};

struct _TerminusMacrosPrivate {
	TerminusMacro** macro_list;
	gint macro_list_length1;
	gint _macro_list_size_;
};

static gint TerminusMacro_private_offset;
static gpointer terminus_macro_parent_class = NULL;
static gint TerminusMacros_private_offset;
static gpointer terminus_macros_parent_class = NULL;
VALA_EXTERN GSettings* terminus_settings;

VALA_EXTERN GType terminus_macro_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (TerminusMacro, g_object_unref)
VALA_EXTERN TerminusMacro* terminus_macro_new (const gchar* key,
                                   const gchar* command);
VALA_EXTERN TerminusMacro* terminus_macro_construct (GType object_type,
                                         const gchar* key,
                                         const gchar* command);
VALA_EXTERN gchar* terminus_macro_check_macro (TerminusMacro* self,
                                   GdkEventKey* event);
static void terminus_macro_finalize (GObject * obj);
static GType terminus_macro_get_type_once (void);
VALA_EXTERN GType terminus_macros_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (TerminusMacros, g_object_unref)
VALA_EXTERN TerminusMacros* terminus_macros_new (void);
VALA_EXTERN TerminusMacros* terminus_macros_construct (GType object_type);
static void __lambda43_ (TerminusMacros* self,
                  const gchar* key);
VALA_EXTERN void terminus_macros_update_macros (TerminusMacros* self);
static void ___lambda43__g_settings_changed (GSettings* _sender,
                                      const gchar* key,
                                      gpointer self);
static void _vala_array_add2 (TerminusMacro** * array,
                       gint* length,
                       gint* size,
                       TerminusMacro* value);
VALA_EXTERN gchar* terminus_macros_check_macro (TerminusMacros* self,
                                    GdkEventKey* event);
static void terminus_macros_finalize (GObject * obj);
static GType terminus_macros_get_type_once (void);
static void _vala_array_destroy (gpointer array,
                          gssize array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gssize array_length,
                       GDestroyNotify destroy_func);

static inline gpointer
terminus_macro_get_instance_private (TerminusMacro* self)
{
	return G_STRUCT_MEMBER_P (self, TerminusMacro_private_offset);
}

TerminusMacro*
terminus_macro_construct (GType object_type,
                          const gchar* key,
                          const gchar* command)
{
	TerminusMacro * self = NULL;
	guint keyval = 0U;
	GdkModifierType state = 0U;
	guint _tmp0_ = 0U;
	GdkModifierType _tmp1_ = 0U;
	gboolean _tmp2_ = FALSE;
	gchar* _tmp3_;
	g_return_val_if_fail (key != NULL, NULL);
	g_return_val_if_fail (command != NULL, NULL);
	self = (TerminusMacro*) g_object_new (object_type, NULL);
	gtk_accelerator_parse (key, &_tmp0_, &_tmp1_);
	keyval = _tmp0_;
	state = _tmp1_;
	if (keyval >= ((guint) 'a')) {
		_tmp2_ = keyval <= ((guint) 'z');
	} else {
		_tmp2_ = FALSE;
	}
	if (_tmp2_) {
		keyval &= (guint) (~32);
	}
	self->priv->keyval = keyval;
	self->priv->state = state;
	_tmp3_ = g_strdup (command);
	_g_free0 (self->priv->command);
	self->priv->command = _tmp3_;
	return self;
}

TerminusMacro*
terminus_macro_new (const gchar* key,
                    const gchar* command)
{
	return terminus_macro_construct (TERMINUS_TYPE_MACRO, key, command);
}

gchar*
terminus_macro_check_macro (TerminusMacro* self,
                            GdkEventKey* event)
{
	gboolean _tmp0_ = FALSE;
	gchar* result;
	g_return_val_if_fail (self != NULL, NULL);
	g_return_val_if_fail (event != NULL, NULL);
	if (self->priv->keyval == event->keyval) {
		_tmp0_ = self->priv->state == event->state;
	} else {
		_tmp0_ = FALSE;
	}
	if (_tmp0_) {
		const gchar* _tmp1_;
		gchar* _tmp2_;
		_tmp1_ = self->priv->command;
		_tmp2_ = g_strdup (_tmp1_);
		result = _tmp2_;
		return result;
	} else {
		result = NULL;
		return result;
	}
}

static void
terminus_macro_class_init (TerminusMacroClass * klass,
                           gpointer klass_data)
{
	terminus_macro_parent_class = g_type_class_peek_parent (klass);
	g_type_class_adjust_private_offset (klass, &TerminusMacro_private_offset);
	G_OBJECT_CLASS (klass)->finalize = terminus_macro_finalize;
}

static void
terminus_macro_instance_init (TerminusMacro * self,
                              gpointer klass)
{
	self->priv = terminus_macro_get_instance_private (self);
}

static void
terminus_macro_finalize (GObject * obj)
{
	TerminusMacro * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TERMINUS_TYPE_MACRO, TerminusMacro);
	_g_free0 (self->priv->command);
	G_OBJECT_CLASS (terminus_macro_parent_class)->finalize (obj);
}

static GType
terminus_macro_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (TerminusMacroClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) terminus_macro_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (TerminusMacro), 0, (GInstanceInitFunc) terminus_macro_instance_init, NULL };
	GType terminus_macro_type_id;
	terminus_macro_type_id = g_type_register_static (G_TYPE_OBJECT, "TerminusMacro", &g_define_type_info, 0);
	TerminusMacro_private_offset = g_type_add_instance_private (terminus_macro_type_id, sizeof (TerminusMacroPrivate));
	return terminus_macro_type_id;
}

GType
terminus_macro_get_type (void)
{
	static volatile gsize terminus_macro_type_id__once = 0;
	if (g_once_init_enter (&terminus_macro_type_id__once)) {
		GType terminus_macro_type_id;
		terminus_macro_type_id = terminus_macro_get_type_once ();
		g_once_init_leave (&terminus_macro_type_id__once, terminus_macro_type_id);
	}
	return terminus_macro_type_id__once;
}

static inline gpointer
terminus_macros_get_instance_private (TerminusMacros* self)
{
	return G_STRUCT_MEMBER_P (self, TerminusMacros_private_offset);
}

static void
__lambda43_ (TerminusMacros* self,
             const gchar* key)
{
	g_return_if_fail (key != NULL);
	if (g_strcmp0 (key, "macros") == 0) {
		terminus_macros_update_macros (self);
	}
}

static void
___lambda43__g_settings_changed (GSettings* _sender,
                                 const gchar* key,
                                 gpointer self)
{
	__lambda43_ ((TerminusMacros*) self, key);
}

TerminusMacros*
terminus_macros_construct (GType object_type)
{
	TerminusMacros * self = NULL;
	GSettings* _tmp0_;
	self = (TerminusMacros*) g_object_new (object_type, NULL);
	_tmp0_ = terminus_settings;
	g_signal_connect_object (_tmp0_, "changed", (GCallback) ___lambda43__g_settings_changed, self, 0);
	terminus_macros_update_macros (self);
	return self;
}

TerminusMacros*
terminus_macros_new (void)
{
	return terminus_macros_construct (TERMINUS_TYPE_MACROS);
}

static gpointer
_g_object_ref0 (gpointer self)
{
	return self ? g_object_ref (self) : NULL;
}

static void
_vala_array_add2 (TerminusMacro** * array,
                  gint* length,
                  gint* size,
                  TerminusMacro* value)
{
	if ((*length) == (*size)) {
		*size = (*size) ? (2 * (*size)) : 4;
		*array = g_renew (TerminusMacro*, *array, (*size) + 1);
	}
	(*array)[(*length)++] = value;
	(*array)[*length] = NULL;
}

void
terminus_macros_update_macros (TerminusMacros* self)
{
	TerminusMacro** _tmp0_;
	GVariant* macros = NULL;
	GSettings* _tmp1_;
	GVariant* _tmp2_;
	g_return_if_fail (self != NULL);
	_tmp0_ = g_new0 (TerminusMacro*, 0 + 1);
	self->priv->macro_list = (_vala_array_free (self->priv->macro_list, self->priv->macro_list_length1, (GDestroyNotify) g_object_unref), NULL);
	self->priv->macro_list = _tmp0_;
	self->priv->macro_list_length1 = 0;
	self->priv->_macro_list_size_ = self->priv->macro_list_length1;
	_tmp1_ = terminus_settings;
	_tmp2_ = g_settings_get_value (_tmp1_, "macros");
	macros = _tmp2_;
	{
		GVariantIter* _entry_it = NULL;
		GVariant* _tmp3_;
		GVariantIter* _tmp4_;
		GVariant* entry = NULL;
		_tmp3_ = macros;
		_tmp4_ = g_variant_iter_new (_tmp3_);
		_entry_it = _tmp4_;
		while (TRUE) {
			GVariantIter* _tmp5_;
			GVariant* _tmp6_;
			GVariant* _tmp7_;
			GVariant* key = NULL;
			GVariant* _tmp8_;
			GVariant* _tmp9_;
			GVariant* command = NULL;
			GVariant* _tmp10_;
			GVariant* _tmp11_;
			TerminusMacro* macro = NULL;
			GVariant* _tmp12_;
			const gchar* _tmp13_;
			GVariant* _tmp14_;
			const gchar* _tmp15_;
			TerminusMacro* _tmp16_;
			TerminusMacro* _tmp17_;
			TerminusMacro* _tmp18_;
			_tmp5_ = _entry_it;
			_tmp6_ = g_variant_iter_next_value (_tmp5_);
			_g_variant_unref0 (entry);
			entry = _tmp6_;
			_tmp7_ = entry;
			if (!(_tmp7_ != NULL)) {
				break;
			}
			_tmp8_ = entry;
			_tmp9_ = g_variant_get_child_value (_tmp8_, (gsize) 0);
			key = _tmp9_;
			_tmp10_ = entry;
			_tmp11_ = g_variant_get_child_value (_tmp10_, (gsize) 1);
			command = _tmp11_;
			_tmp12_ = key;
			_tmp13_ = g_variant_get_string (_tmp12_, NULL);
			_tmp14_ = command;
			_tmp15_ = g_variant_get_string (_tmp14_, NULL);
			_tmp16_ = terminus_macro_new (_tmp13_, _tmp15_);
			macro = _tmp16_;
			_tmp17_ = macro;
			_tmp18_ = _g_object_ref0 (_tmp17_);
			_vala_array_add2 (&self->priv->macro_list, &self->priv->macro_list_length1, &self->priv->_macro_list_size_, _tmp18_);
			_g_object_unref0 (macro);
			_g_variant_unref0 (command);
			_g_variant_unref0 (key);
		}
		_g_variant_unref0 (entry);
		_g_variant_iter_free0 (_entry_it);
	}
	_g_variant_unref0 (macros);
}

gchar*
terminus_macros_check_macro (TerminusMacros* self,
                             GdkEventKey* event)
{
	TerminusMacro** _tmp0_;
	gint _tmp0__length1;
	gchar* result;
	g_return_val_if_fail (self != NULL, NULL);
	g_return_val_if_fail (event != NULL, NULL);
	_tmp0_ = self->priv->macro_list;
	_tmp0__length1 = self->priv->macro_list_length1;
	{
		TerminusMacro** macro_collection = NULL;
		gint macro_collection_length1 = 0;
		gint _macro_collection_size_ = 0;
		gint macro_it = 0;
		macro_collection = _tmp0_;
		macro_collection_length1 = _tmp0__length1;
		for (macro_it = 0; macro_it < macro_collection_length1; macro_it = macro_it + 1) {
			TerminusMacro* _tmp1_;
			TerminusMacro* macro = NULL;
			_tmp1_ = _g_object_ref0 (macro_collection[macro_it]);
			macro = _tmp1_;
			{
				gchar* command = NULL;
				TerminusMacro* _tmp2_;
				gchar* _tmp3_;
				const gchar* _tmp4_;
				_tmp2_ = macro;
				_tmp3_ = terminus_macro_check_macro (_tmp2_, event);
				command = _tmp3_;
				_tmp4_ = command;
				if (_tmp4_ != NULL) {
					result = command;
					_g_object_unref0 (macro);
					return result;
				}
				_g_free0 (command);
				_g_object_unref0 (macro);
			}
		}
	}
	result = NULL;
	return result;
}

static void
terminus_macros_class_init (TerminusMacrosClass * klass,
                            gpointer klass_data)
{
	terminus_macros_parent_class = g_type_class_peek_parent (klass);
	g_type_class_adjust_private_offset (klass, &TerminusMacros_private_offset);
	G_OBJECT_CLASS (klass)->finalize = terminus_macros_finalize;
}

static void
terminus_macros_instance_init (TerminusMacros * self,
                               gpointer klass)
{
	self->priv = terminus_macros_get_instance_private (self);
}

static void
terminus_macros_finalize (GObject * obj)
{
	TerminusMacros * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TERMINUS_TYPE_MACROS, TerminusMacros);
	self->priv->macro_list = (_vala_array_free (self->priv->macro_list, self->priv->macro_list_length1, (GDestroyNotify) g_object_unref), NULL);
	G_OBJECT_CLASS (terminus_macros_parent_class)->finalize (obj);
}

static GType
terminus_macros_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (TerminusMacrosClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) terminus_macros_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (TerminusMacros), 0, (GInstanceInitFunc) terminus_macros_instance_init, NULL };
	GType terminus_macros_type_id;
	terminus_macros_type_id = g_type_register_static (G_TYPE_OBJECT, "TerminusMacros", &g_define_type_info, 0);
	TerminusMacros_private_offset = g_type_add_instance_private (terminus_macros_type_id, sizeof (TerminusMacrosPrivate));
	return terminus_macros_type_id;
}

GType
terminus_macros_get_type (void)
{
	static volatile gsize terminus_macros_type_id__once = 0;
	if (g_once_init_enter (&terminus_macros_type_id__once)) {
		GType terminus_macros_type_id;
		terminus_macros_type_id = terminus_macros_get_type_once ();
		g_once_init_leave (&terminus_macros_type_id__once, terminus_macros_type_id);
	}
	return terminus_macros_type_id__once;
}

static void
_vala_array_destroy (gpointer array,
                     gssize array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		gssize i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gssize array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

